package com.muyu.marketing.domain.model;


import com.muyu.marketing.domain.ActivityTeamProductSkuInfo;
import com.muyu.marketing.domain.req.TeamProjectSkuInfoAddReq;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;
import java.util.function.Supplier;

/**
 * spu回显模型
 *
 * @author DongZeLiang
 * @date 2024-11-26 09:36
 */
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ActivityTeamProductSkuDetailModel {

    /**
     * 规格id
     */
    public Long id;
    /**
     * 团购活动ID
     */
    private Long teamId;

    /**
     * 商品ID
     */
    private Long productId;

    /**
     * 规格SKU
     */
    private String productSku;

    /**
     * 拼团价格
     */
    private BigDecimal teamPrice;

    /**
     * 拼团库存
     */
    private Long teamStock;



    /**
     * sku回显构造器
     * @param activityTeamProductSkuInfo
     * @return
     */
    public static ActivityTeamProductSkuDetailModel getInstance(ActivityTeamProductSkuInfo activityTeamProductSkuInfo) {
        return ActivityTeamProductSkuDetailModel.builder()
                .id(activityTeamProductSkuInfo.getId())
                .teamId(activityTeamProductSkuInfo.getTeamId())
                .productId(activityTeamProductSkuInfo.getProductId())
                .productSku(activityTeamProductSkuInfo.getProductSku())
                .teamPrice(activityTeamProductSkuInfo.getTeamPrice())
                .teamStock(activityTeamProductSkuInfo.getTeamStock())
                .build();
    }


}
