package com.muyu.marketing.domain.model;

import com.muyu.marketing.domain.req.ActivityTeamProjectSkuInfoUpdReq;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.math.BigDecimal;

/**
 * sku修改模型
 */
@Data
@SuperBuilder
@AllArgsConstructor
@NoArgsConstructor
public class ActivityTeamProjectSkuInfoUpdModel {

    /**
     * 规格id
     */
    public Long id;
    /**
     * 团购活动ID
     */
    private Long teamId;

    /**
     * 商品ID
     */
    private Long productId;

    /**
     * 规格SKU
     */
    private String productSku;

    /**
     * 拼团价格
     */
    private BigDecimal teamPrice;

    /**
     * 拼团库存
     */
    private Long teamStock;

    public static ActivityTeamProjectSkuInfoUpdModel updSkuModel(ActivityTeamProjectSkuInfoUpdReq activityTeamProjectSkuInfoUpdReq) {
        return ActivityTeamProjectSkuInfoUpdModel.builder()
                .id(activityTeamProjectSkuInfoUpdReq.getId())
                .teamId(activityTeamProjectSkuInfoUpdReq.getTeamId())
                .productId(activityTeamProjectSkuInfoUpdReq.getProductId())
                .productSku(activityTeamProjectSkuInfoUpdReq.getProductSku())
                .teamPrice(activityTeamProjectSkuInfoUpdReq.getTeamPrice())
                .teamStock(activityTeamProjectSkuInfoUpdReq.getTeamStock())
                .build();
    }


}
