package com.muyu.marketing.domain.resp;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.muyu.common.core.web.domain.BaseEntity;
import com.muyu.marketing.domain.model.ActivityTeamDetailModel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.util.Date;
import java.util.List;
import java.util.function.Function;

/**
 * 活动回显
 */
@Data
@SuperBuilder
@NoArgsConstructor
@AllArgsConstructor
@EqualsAndHashCode(callSuper = true)
public class ActivityTeamDetailResp extends BaseEntity {

    /**
     * 活动ID
     */
    private Long id;
    /**
     * 拼团名称
     */
    private String name;
    /**
     * 商品ID
     */
    private Long productId;
    /**
     * 商品活动图
     */
    private String productImage;
    /**
     * 活动简介
     */
    private String introduction;
    /**
     * 单位
     */

    private String unit;
    /**
     * 轮播图
     */

    private String imageList;
    /**
     * 活动结束时间
     */
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd")
    private Date endTime;
    /**
     * 活动排序
     */
    private Long sort;
    /**
     * 商品SkU集合
     */
    private List<ActivityTeamProjectSkuInfoResp> skuInfoRespList;
    /**
     * 活动详情
     */
    private String content;
    /**
     * 活动状态
     */
    private String status;
    /**
     * 策略类型
     */
    private String strategyType;
    /**
     * 策略ID
     */
    private Long strategyId;


    public static ActivityTeamDetailResp findByid(ActivityTeamDetailModel ActivityTeamDetailModel, Function<Long,List<ActivityTeamProjectSkuInfoResp>> skuInfoRespList) {
        return ActivityTeamDetailResp.builder()
                .id(ActivityTeamDetailModel.getId())
                .name(ActivityTeamDetailModel.getName())
                .productId(ActivityTeamDetailModel.getProductId())
                .productImage(ActivityTeamDetailModel.getProductImage())
                .introduction(ActivityTeamDetailModel.getIntroduction())
                .unit(ActivityTeamDetailModel.getUnit())
                .imageList(ActivityTeamDetailModel.getImageList())
                .endTime(ActivityTeamDetailModel.getEndTime())
                .sort(ActivityTeamDetailModel.getSort())
                .content(ActivityTeamDetailModel.getContent())
                .status(ActivityTeamDetailModel.getStatus())
                .strategyType(ActivityTeamDetailModel.getStrategyType())
                .strategyId(ActivityTeamDetailModel.getStrategyId())
                .skuInfoRespList(skuInfoRespList.apply(ActivityTeamDetailModel.getId()))
                .build();
    }

}
