package com.muyu.marketing.domain.resp;

import com.muyu.marketing.domain.model.ActivityTeamProductSkuDetailModel;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.experimental.SuperBuilder;

import java.math.BigDecimal;
import java.util.List;

/**
 * sku回显对象
 */
@Data
@SuperBuilder
@AllArgsConstructor
@NoArgsConstructor
public class ActivityTeamProjectSkuInfoResp {

    /**
     * 规格id
     */
    public Long id;
    /**
     * 团购活动ID
     */
    private Long teamId;

    /**
     * 商品ID
     */
    private Long productId;

    /**
     * 规格SKU
     */
    private String productSku;

    /**
     * 拼团价格
     */
    private BigDecimal teamPrice;

    /**
     * 拼团库存
     */
    private Long teamStock;


    public static List<ActivityTeamProjectSkuInfoResp> findSkuId(List<ActivityTeamProductSkuDetailModel> activityTeamProductSkuDetailModel) {
        return activityTeamProductSkuDetailModel.stream().map(activityTeamProductSkuDetailModel1 -> {
            ActivityTeamProjectSkuInfoResp teamProjectSkuInfoResp = ActivityTeamProjectSkuInfoResp.builder()
                    .teamId(activityTeamProductSkuDetailModel1.getTeamId())
                    .productSku(activityTeamProductSkuDetailModel1.getProductSku())
                    .productSku(activityTeamProductSkuDetailModel1.getProductSku())
                    .teamPrice(activityTeamProductSkuDetailModel1.getTeamPrice())
                    .build();
            return teamProjectSkuInfoResp;
        }).toList();
    }
}
